/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOEDITAL                                               */
/* Tabela : TIPOEDITAL                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 09/08/2004 - WELBERT G. MOITINHA                                           */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOEDITAL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOEDITAL
GO

CREATE TRIGGER DTULTATU_TIPOEDITAL
ON TIPOEDITAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOEDITAL', null, 'CDTIPOEDITAL=' + CDTIPOEDITAL + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOEDITAL
      SET DTULTATUTPED = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOEDITAL.CDTIPOEDITAL,0) = ISNULL(INSERTED.CDTIPOEDITAL,0)) AND
            (ISNULL(TIPOEDITAL.NMTIPOEDITAL,0) = ISNULL(INSERTED.NMTIPOEDITAL,0)) ;
   END;
END;
GO
